package  
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import flash.display.BlendMode;
	import net.flashpunk.graphics.Image;
	/**
	 * ...
	 * @author 
	 */
	public class LightEngine 
	{
		private static var lights:Vector.<Light> = new Vector.<Light>;
		private static var bmp:BitmapData = new BitmapData(FP.screen.width, FP.screen.height, false, 0);
		
		public function LightEngine() 
		{
			
		}
		
		public static function Render(_bmp:BitmapData, _blendMode:String=BlendMode.MULTIPLY, _colorTrans:ColorTransform=null):void
		{
			for (var i:int = 0; i < lights.length; i++)
				lights[i].draw(bmp);
				
			if (!_colorTrans)
				_colorTrans = new ColorTransform(1.2, 1, 1.1, 0.7, 15, 0, 10);
			
			_bmp.draw(bmp, null, _colorTrans, _blendMode);
			bmp.fillRect(bmp.rect, 0);
		}
		
		public static function AddLight(l:Light):void
		{
			lights.push(l);
		}
		
		public static function RemoveLight(l:Light):void
		{
			var ind:int = lights.indexOf(l);
			if(ind != -1)
				lights.splice(ind, 1);
		}
		
		//Call this to draw any sprite to the light surface.
		public static function DrawImage(position:Point, image:Image):void
		{
			image.render(bmp, position, FP.camera);
		}
		
	}

}