package  
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import net.flashpunk.FP;
	import flash.display.BlendMode
	/**
	 * ...
	 * @author 
	 */
	public class WaterEngine 
	{
		public static var bmp:BitmapData = new BitmapData(FP.screen.width, FP.screen.height);
		
		public static const noises:int = 2;
		public static var noise:Vector.<BitmapData> = new Vector.<BitmapData>;
		private static var offset:int = 0;
		
		public function WaterEngine() 
		{
			
		}
		
		public static function Start():void
		{
			for (var i:int = 0; i < noises; i++)
			{
				var b:BitmapData = new BitmapData(FP.screen.width, FP.screen.height);
				b.perlinNoise(48, 16, 16, Math.random() * 1000000, true, true,7, true);
				noise.push(b);
			}
		}
		
		public static function Update():void
		{
			offset = (offset + 1) % bmp.width;
		}
		
		public static function Render(_bmp:BitmapData):void
		{
			_bmp.draw(bmp, null, null, BlendMode.NORMAL);
			bmp.fillRect(bmp.rect, 0);
			for (var i:int = 0; i < noise.length; i++)
			{
				for (var j:int = 0; j < 4; j++)
				{
					var m:Matrix;
					if (i == 0)
						m = new Matrix(1, 0, 0, 1, bmp.width -offset,-offset * bmp.height / bmp.width);
					else
						m = new Matrix(1, 0, 0, 1, offset, -offset * bmp.height / bmp.width);
					
					if (j < 2)
						m.translate(-bmp.width, 0);
					if (j % 2)
						m.translate(0, bmp.height);
					bmp.draw(noise[i], m, new ColorTransform(1, 1, 1, 0.5), BlendMode.ADD);
				}
			}
			LightEngine.Render(bmp, BlendMode.ADD, new ColorTransform(1,1, 1, 0.9));
			const threshold:uint = 0xFFe0e0e0;
			bmp.threshold(bmp, bmp.rect, new Point, "<=", threshold, 0);
			//bmp.threshold(bmp, bmp.rect, new Point, ">", threshold, 0xFF400404);
		}
		
	}

}