package  
{
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import flash.display.BlendMode;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author 
	 */
	public class Light extends Entity
	{
		[Embed(source = "../assets/graphics/Light.png")] private static const imgLight:Class;
		
		private var sprLight:Image;
		
		public var z:Number = 0;
		
		public function set color(n:uint):void
		{
			sprLight.color = n;
		}
		public function get color():uint
		{
			return sprLight.color;
		}
		
		public function SetSize(w:int, h:int):void
		{
			sprLight.scaleX = w / sprLight.width;
			sprLight.scaleY = h / sprLight.height;
		}
		
		public function Light(_x:int, _y:int, _w:int=NaN, _h:int=NaN, _color:uint=0xFFFFFF) 
		{
			super(_x, _y);
			sprLight = new Image(imgLight);
			color = _color;
			sprLight.centerOO();
			if(!isNaN(_w) && !isNaN(_h))
				SetSize(_w, _h);
		}
		
		public function draw(_bmp:BitmapData):void
		{
			sprLight.blend = BlendMode.ADD;
			sprLight.color = color;
			sprLight.render(_bmp, new Point(x, y + z), FP.camera);
		}
		
		override public function added():void
		{
			LightEngine.AddLight(this);
		}
		
		override public function removed():void
		{
			LightEngine.RemoveLight(this);
		}
		
	}

}